/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the WaitUntil type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WaitUntil{}

// WaitUntil In mode `exact` we simply wait until provided date time.  In mode `time` date part is ignored and we wait until the closest time in future, respecting timezones.  For example: `until` is set to `xxxx-xx-xx 15:15:00`, if users current time is `14:15` then we wait 1 hour, on the other hand if users time is `16:00` we wait until `15:15` the next day.
type WaitUntil struct {
	Mode string `json:"mode"`
	Until time.Time `json:"until"`
	// Valid for mode `time` only, adds set amount of days to wait
	AddDays *int32 `json:"add_days,omitempty"`
	// List of weekdays that wait should omit and jump to next available day.  0 - Sunday
	ExcludeWeekdays []int32 `json:"exclude_weekdays,omitempty"`
	// Which time zone should we use
	TimeZoneType *string `json:"time_zone_type,omitempty"`
}

// NewWaitUntil instantiates a new WaitUntil object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWaitUntil(mode string, until time.Time) *WaitUntil {
	this := WaitUntil{}
	this.Mode = mode
	this.Until = until
	return &this
}

// NewWaitUntilWithDefaults instantiates a new WaitUntil object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWaitUntilWithDefaults() *WaitUntil {
	this := WaitUntil{}
	return &this
}

// GetMode returns the Mode field value
func (o *WaitUntil) GetMode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Mode
}

// GetModeOk returns a tuple with the Mode field value
// and a boolean to check if the value has been set.
func (o *WaitUntil) GetModeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Mode, true
}

// SetMode sets field value
func (o *WaitUntil) SetMode(v string) {
	o.Mode = v
}

// GetUntil returns the Until field value
func (o *WaitUntil) GetUntil() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Until
}

// GetUntilOk returns a tuple with the Until field value
// and a boolean to check if the value has been set.
func (o *WaitUntil) GetUntilOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Until, true
}

// SetUntil sets field value
func (o *WaitUntil) SetUntil(v time.Time) {
	o.Until = v
}

// GetAddDays returns the AddDays field value if set, zero value otherwise.
func (o *WaitUntil) GetAddDays() int32 {
	if o == nil || IsNil(o.AddDays) {
		var ret int32
		return ret
	}
	return *o.AddDays
}

// GetAddDaysOk returns a tuple with the AddDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WaitUntil) GetAddDaysOk() (*int32, bool) {
	if o == nil || IsNil(o.AddDays) {
		return nil, false
	}
	return o.AddDays, true
}

// HasAddDays returns a boolean if a field has been set.
func (o *WaitUntil) HasAddDays() bool {
	if o != nil && !IsNil(o.AddDays) {
		return true
	}

	return false
}

// SetAddDays gets a reference to the given int32 and assigns it to the AddDays field.
func (o *WaitUntil) SetAddDays(v int32) {
	o.AddDays = &v
}

// GetExcludeWeekdays returns the ExcludeWeekdays field value if set, zero value otherwise.
func (o *WaitUntil) GetExcludeWeekdays() []int32 {
	if o == nil || IsNil(o.ExcludeWeekdays) {
		var ret []int32
		return ret
	}
	return o.ExcludeWeekdays
}

// GetExcludeWeekdaysOk returns a tuple with the ExcludeWeekdays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WaitUntil) GetExcludeWeekdaysOk() ([]int32, bool) {
	if o == nil || IsNil(o.ExcludeWeekdays) {
		return nil, false
	}
	return o.ExcludeWeekdays, true
}

// HasExcludeWeekdays returns a boolean if a field has been set.
func (o *WaitUntil) HasExcludeWeekdays() bool {
	if o != nil && !IsNil(o.ExcludeWeekdays) {
		return true
	}

	return false
}

// SetExcludeWeekdays gets a reference to the given []int32 and assigns it to the ExcludeWeekdays field.
func (o *WaitUntil) SetExcludeWeekdays(v []int32) {
	o.ExcludeWeekdays = v
}

// GetTimeZoneType returns the TimeZoneType field value if set, zero value otherwise.
func (o *WaitUntil) GetTimeZoneType() string {
	if o == nil || IsNil(o.TimeZoneType) {
		var ret string
		return ret
	}
	return *o.TimeZoneType
}

// GetTimeZoneTypeOk returns a tuple with the TimeZoneType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WaitUntil) GetTimeZoneTypeOk() (*string, bool) {
	if o == nil || IsNil(o.TimeZoneType) {
		return nil, false
	}
	return o.TimeZoneType, true
}

// HasTimeZoneType returns a boolean if a field has been set.
func (o *WaitUntil) HasTimeZoneType() bool {
	if o != nil && !IsNil(o.TimeZoneType) {
		return true
	}

	return false
}

// SetTimeZoneType gets a reference to the given string and assigns it to the TimeZoneType field.
func (o *WaitUntil) SetTimeZoneType(v string) {
	o.TimeZoneType = &v
}

func (o WaitUntil) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WaitUntil) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["mode"] = o.Mode
	toSerialize["until"] = o.Until
	if !IsNil(o.AddDays) {
		toSerialize["add_days"] = o.AddDays
	}
	if !IsNil(o.ExcludeWeekdays) {
		toSerialize["exclude_weekdays"] = o.ExcludeWeekdays
	}
	if !IsNil(o.TimeZoneType) {
		toSerialize["time_zone_type"] = o.TimeZoneType
	}
	return toSerialize, nil
}

type NullableWaitUntil struct {
	value *WaitUntil
	isSet bool
}

func (v NullableWaitUntil) Get() *WaitUntil {
	return v.value
}

func (v *NullableWaitUntil) Set(val *WaitUntil) {
	v.value = val
	v.isSet = true
}

func (v NullableWaitUntil) IsSet() bool {
	return v.isSet
}

func (v *NullableWaitUntil) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWaitUntil(val *WaitUntil) *NullableWaitUntil {
	return &NullableWaitUntil{value: val, isSet: true}
}

func (v NullableWaitUntil) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWaitUntil) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


